> ## Documentation Index
> Fetch the complete documentation index at: https://developers.avacloud.io/llms.txt
> Use this file to discover all available pages before exploring further.

# List historical rewards

> Lists historical rewards on the Primary Network for the supplied addresses.



## OpenAPI

````yaml get /v1/networks/{network}/rewards
openapi: 3.1.0
info:
  title: Data API
  description: >-
    The Data API provides web3 application developers with multi-chain data
    related to Avalanche's primary network, Avalanche subnets, and Ethereum.
    With Data API, you can easily build products that leverage real-time and
    historical transaction and transfer history, native and token balances, and
    various types of token metadata. The API is in Beta and may be subject to
    change.</br></br>If you have feedback or feature requests for the API,
    please submit them <a
    href="https://portal.productboard.com/dndv9ahlkdfye4opdm8ksafi/tabs/4-glacier-api">here</a>.
    Bug reports can be submitted <a
    href="https://docs.google.com/forms/d/e/1FAIpQLSeJQrcp7QoNiqozMDKrVJGX5wpU827d3cVTgF8qa7t_J1Pb-g/viewform">here</a>,
    and any potential security issues can be reported <a
    href="https://immunefi.com/bounty/avalabs">here</a>.
  version: 1.0.0
  contact: {}
servers:
  - url: https://glacier-api.avax.network
security:
  - apiKey: []
  - {}
tags:
  - name: EVM Chains
    description: >-
      Find information about indexed EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Blocks
    description: >-
      Find information about blocks on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Transactions
    description: >-
      Find information about transactions on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Balances
    description: >-
      Find information about balances on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: EVM Contracts
    description: >-
      Find information about contracts on EVM-compatible chains, such as the
      Avalanche C-Chain.
  - name: Primary Network
  - name: Primary Network Blocks
    description: >-
      Find information about blocks on Avalanche's Primary Network Chains - the
      P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Vertices
    description: Find information about vertices on Avalanche's X-Chain.
  - name: Primary Network Transactions
    description: >-
      Find information about transactions on Avalanche's Primary Network Chains
      - the P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Balances
    description: >-
      Find information about balances on Avalanche's Primary Network Chains -
      the P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network UTXOs
    description: >-
      Find information about utxos on Avalanche's Primary Network Chains - the
      P-Chain, the X-Chain, and the C-Chain.
  - name: Primary Network Rewards
    description: Find information about rewards on Avalanche's Primary Network.
  - name: NFTs
  - name: Operations
  - name: Health Check
  - name: Teleporter
    description: Find information about Teleporter transactions.
  - name: Interchain Messaging
    description: Find information about Interchain Messaging transactions.
  - name: Webhooks
    description: Manage webhooks and get notified for various onchain activities.
  - name: RPC
    description: Interact with chain nodes using JSON-RPC.
  - name: Data API Usage Metrics
    description: Usage metrics and logs for the Data API.
  - name: Signature Aggregator
    description: Request signatures for a Warp message from Subnet validators
  - name: Notifications
    description: Get notifications for validator status and activity issues.
  - name: AVAX Supply
    description: Find information about AVAX supply.
paths:
  /v1/networks/{network}/rewards:
    get:
      tags:
        - Primary Network Rewards
      summary: List historical rewards
      description: >-
        Lists historical rewards on the Primary Network for the supplied
        addresses.
      operationId: listHistoricalPrimaryNetworkRewards
      parameters:
        - name: addresses
          required: false
          in: query
          description: >-
            A comma separated list of X-Chain or P-Chain wallet addresses,
            starting with "avax"/"fuji", "P-avax"/"P-fuji" or "X-avax"/"X-fuji".
            Optional, but at least one of addresses or nodeIds is required.
          example: avax1h2ccj9f5ay5acl6tyn9mwmw32p8wref8vl8ctg
          schema:
            type: string
        - name: pageToken
          required: false
          in: query
          description: >-
            A page token, received from a previous list call. Provide this to
            retrieve the subsequent page.
          schema:
            type: string
        - name: pageSize
          required: false
          in: query
          description: >-
            The maximum number of items to return. The minimum page size is 1.
            The maximum pageSize is 100.
          schema:
            type: integer
            default: 10
            minimum: 1
            maximum: 100
          example: '10'
        - name: network
          required: true
          in: path
          description: Either mainnet or testnet/fuji.
          example: mainnet
          schema:
            $ref: '#/components/schemas/Network'
        - name: nodeIds
          required: false
          in: query
          description: >-
            A comma separated list of node ids to filter by. Optional, but at
            least one of addresses or nodeIds is required.
          example: NodeID-111111111111111111116DBWJs,NodeID-222222222222222222227DBWJs
          schema:
            type: string
        - name: sortOrder
          required: false
          in: query
          example: asc
          description: >-
            The order by which to sort results. Use "asc" for ascending order,
            "desc" for descending order. Sorted by timestamp or the `sortBy`
            query parameter, if provided.
          schema:
            $ref: '#/components/schemas/SortOrder'
        - name: currency
          required: false
          in: query
          description: The currency that return values should use. Defaults to USD.
          example: usd
          schema:
            $ref: '#/components/schemas/CurrencyCode'
      responses:
        '200':
          description: Successful response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListHistoricalRewardsResponse'
        '400':
          description: |-
            Bad requests generally mean the client has passed invalid 
                or malformed parameters. Error messages in the response could help in 
                evaluating the error.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadRequest'
        '401':
          description: |-
            When a client attempts to access resources that require 
                authorization credentials but the client lacks proper authentication 
                in the request, the server responds with 401.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Unauthorized'
        '403':
          description: |-
            When a client attempts to access resources with valid
                credentials but doesn't have the privilege to perform that action, 
                the server responds with 403.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Forbidden'
        '404':
          description: |-
            The error is mostly returned when the client requests
                with either mistyped URL, or the passed resource is moved or deleted, 
                or the resource doesn't exist.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NotFound'
        '429':
          description: |-
            This error is returned when the client has sent too many,
                and has hit the rate limit.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TooManyRequests'
        '500':
          description: |-
            The error is a generic server side error that is 
                returned for any uncaught and unexpected issues on the server side. 
                This should be very rare, and you may reach out to us if the problem 
                persists for a longer duration.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/InternalServerError'
        '502':
          description: |-
            This is an internal error indicating invalid response 
                  received by the client-facing proxy or gateway from the upstream server.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BadGateway'
        '503':
          description: |-
            The error is returned for certain routes on a particular
                Subnet. This indicates an internal problem with our Subnet node, and may 
                not necessarily mean the Subnet is down or affected.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ServiceUnavailable'
      x-codeSamples:
        - lang: javascript
          label: JavaScript
          source: |-
            import { Avalanche } from "@avalanche-sdk/chainkit";

            const avalanche = new Avalanche({
              network: "mainnet",
            });

            async function run() {
              const result = await avalanche.data.primaryNetwork.rewards.listHistoricalRewards({
                addresses: "avax1h2ccj9f5ay5acl6tyn9mwmw32p8wref8vl8ctg",
                pageSize: 10,
                nodeIds: "NodeID-111111111111111111116DBWJs,NodeID-222222222222222222227DBWJs",
                sortOrder: "asc",
                currency: "usd",
              });

              for await (const page of result) {
                console.log(page);
              }
            }

            run();
components:
  schemas:
    Network:
      type: string
      enum:
        - mainnet
        - fuji
        - testnet
    SortOrder:
      type: string
      enum:
        - asc
        - desc
    CurrencyCode:
      type: string
      description: ISO 4217 currency code.
      enum:
        - usd
        - eur
        - aud
        - cad
        - chf
        - clp
        - cny
        - czk
        - dkk
        - gbp
        - hkd
        - huf
        - jpy
        - nzd
    ListHistoricalRewardsResponse:
      type: object
      properties:
        nextPageToken:
          type: string
          description: >-
            A token, which can be sent as `pageToken` to retrieve the next page.
            If this field is omitted or empty, there are no subsequent pages.
        historicalRewards:
          type: array
          items:
            $ref: '#/components/schemas/HistoricalReward'
      required:
        - historicalRewards
    BadRequest:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 400
        error:
          type: string
          description: The type of error
          examples:
            - Bad Request
      required:
        - message
        - statusCode
        - error
    Unauthorized:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 401
        error:
          type: string
          description: The type of error
          examples:
            - Unauthorized
      required:
        - message
        - statusCode
        - error
    Forbidden:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 403
        error:
          type: string
          description: The type of error
          examples:
            - Forbidden
      required:
        - message
        - statusCode
        - error
    NotFound:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 404
        error:
          type: string
          description: The type of error
          examples:
            - Not Found
      required:
        - message
        - statusCode
        - error
    TooManyRequests:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 429
        error:
          type: string
          description: The type of error
          examples:
            - Too Many Requests
      required:
        - message
        - statusCode
        - error
    InternalServerError:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 500
        error:
          type: string
          description: The type of error
          examples:
            - Internal Server Error
      required:
        - message
        - statusCode
        - error
    BadGateway:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 502
        error:
          type: string
          description: The type of error
          examples:
            - Bad Gateway
      required:
        - message
        - statusCode
        - error
    ServiceUnavailable:
      type: object
      properties:
        message:
          description: The error message describing the reason for the exception
          oneOf:
            - type: string
            - type: array
              items:
                type: string
        statusCode:
          type: number
          description: The HTTP status code of the response
          examples:
            - 503
        error:
          type: string
          description: The type of error
          examples:
            - Service Unavailable
      required:
        - message
        - statusCode
        - error
    HistoricalReward:
      type: object
      properties:
        addresses:
          description: An array of P-Chain wallet addresses.
          examples:
            - - avax1h2ccj9f5ay5acl6tyn9mwmw32p8wref8vl8ctg
          type: array
          items:
            type: string
        txHash:
          type: string
        amountStaked:
          type: string
        nodeId:
          type: string
        startTimestamp:
          type: number
        endTimestamp:
          type: number
        rewardType:
          $ref: '#/components/schemas/RewardType'
        utxoId:
          type: string
        outputIndex:
          type: number
        reward:
          $ref: '#/components/schemas/AssetWithPriceInfo'
        rewardTxHash:
          type: string
      required:
        - addresses
        - txHash
        - amountStaked
        - nodeId
        - startTimestamp
        - endTimestamp
        - rewardType
        - utxoId
        - outputIndex
        - reward
        - rewardTxHash
    RewardType:
      type: string
      enum:
        - VALIDATOR
        - DELEGATOR
        - VALIDATOR_FEE
    AssetWithPriceInfo:
      type: object
      properties:
        assetId:
          type: string
          description: Unique ID for an asset.
          examples:
            - th5aLdWLi32yS9ED6uLGoMMubqHjzMsXhKWwzP6yZTYQKYzof
        name:
          type: string
          description: Name of this asset.
          examples:
            - Avalanche
        symbol:
          type: string
          description: Symbol for this asset (max 4 characters).
          examples:
            - AVAX
        denomination:
          type: number
          description: Denomination of this asset to represent fungibility.
          examples:
            - 9
        type:
          $ref: '#/components/schemas/PrimaryNetworkAssetType'
          examples:
            - secp256k1
        amount:
          type: string
          description: Amount of the asset.
          examples:
            - '5001000'
        historicalPrice:
          description: >-
            The historical asset price at the time the reward was granted, if
            available. Note, this is only provided if the reward occured more
            than 24 hours ago.
          allOf:
            - $ref: '#/components/schemas/Money'
      required:
        - assetId
        - name
        - symbol
        - denomination
        - type
        - amount
    PrimaryNetworkAssetType:
      type: string
      description: Type of asset like SECP256K1 or NFT.
      enum:
        - secp256k1
        - nft
    Money:
      type: object
      properties:
        currencyCode:
          $ref: '#/components/schemas/CurrencyCode'
          examples:
            - usd
        value:
          type: number
          description: Monetary value in base 10 decimals.
          examples:
            - '42.42'
      required:
        - currencyCode
        - value
  securitySchemes:
    apiKey:
      type: apiKey
      in: header
      name: x-glacier-api-key
      description: >-
        Api keys provide higher access to rate limits. To obtain an api key,
        sign up for an account at https://avacloud.io/.

````